"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }var _path = require('path'); var _path2 = _interopRequireDefault(_path);
var _fsextra = require('fs-extra'); var _fsextra2 = _interopRequireDefault(_fsextra);
var _picocolors = require('picocolors'); var _picocolors2 = _interopRequireDefault(_picocolors);
var _resolve = require('resolve'); var _resolve2 = _interopRequireDefault(_resolve);
var _getPaths = require('./getPaths');
const getAdditionalModulePaths = (options = {}) => {
  const paths = _getPaths.getPaths.call(void 0, );
  const baseUrl = options.baseUrl;
  if (!baseUrl) {
    return "";
  }
  const baseUrlResolved = _path2.default.resolve(paths.appPath, baseUrl);
  if (_path2.default.relative(paths.appNodeModules, baseUrlResolved) === "") {
    return null;
  }
  if (_path2.default.relative(paths.appSrc, baseUrlResolved) === "") {
    return [paths.appSrc];
  }
  if (_path2.default.relative(paths.appPath, baseUrlResolved) === "") {
    return null;
  }
  throw new Error(
    _picocolors2.default.red(
      _picocolors2.default.bold(
        "Your project's `baseUrl` can only be set to `src` or `node_modules`. Create React App does not support other values at this time."
      )
    )
  );
};
const getWebpackAliases = (options = {}) => {
  const paths = _getPaths.getPaths.call(void 0, );
  const baseUrl = options.baseUrl;
  if (!baseUrl) {
    return {};
  }
  const baseUrlResolved = _path2.default.resolve(paths.appPath, baseUrl);
  if (_path2.default.relative(paths.appPath, baseUrlResolved) === "") {
    return {
      src: paths.appSrc
    };
  } else {
    return {};
  }
};
const getModules = () => {
  const paths = _getPaths.getPaths.call(void 0, );
  const hasTsConfig = _fsextra2.default.existsSync(paths.appTsConfig);
  const hasJsConfig = _fsextra2.default.existsSync(paths.appJsConfig);
  if (hasTsConfig && hasJsConfig) {
    throw new Error(
      "You have both a tsconfig.json and a jsconfig.json. If you are using TypeScript please remove your jsconfig.json file."
    );
  }
  let config;
  if (hasTsConfig) {
    const ts = require(_resolve2.default.sync("typescript", {
      basedir: paths.appNodeModules
    }));
    config = ts.readConfigFile(paths.appTsConfig, ts.sys.readFile).config;
  } else if (hasJsConfig) {
    config = require(paths.appJsConfig);
  }
  config = config || {};
  const options = config.compilerOptions || {};
  const additionalModulePaths = getAdditionalModulePaths(options);
  return {
    additionalModulePaths,
    webpackAliases: getWebpackAliases(options),
    hasTsConfig
  };
};


exports.getModules = getModules;
