"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }var _path = require('path'); var _path2 = _interopRequireDefault(_path);
var _fsextra = require('fs-extra'); var _fsextra2 = _interopRequireDefault(_fsextra);
var _getPublicUrlOrPath = require('react-dev-utils/getPublicUrlOrPath'); var _getPublicUrlOrPath2 = _interopRequireDefault(_getPublicUrlOrPath);
var _getUserConfig = require('./getUserConfig');
const getPaths = () => {
  const appDirectory = _fsextra2.default.realpathSync(process.cwd());
  const resolveApp = (relativePath) => _path2.default.resolve(appDirectory, relativePath);
  const publicUrlOrPath = _getPublicUrlOrPath2.default.call(void 0, 
    process.env.NODE_ENV === "development",
    require(resolveApp("package.json")).homepage,
    process.env.PUBLIC_URL
  );
  const distDir = _getUserConfig.getUserConfig.call(void 0, "distDir");
  const moduleFileExtensions = [
    "web.mjs",
    "mjs",
    "web.js",
    "js",
    "web.ts",
    "ts",
    "web.tsx",
    "tsx",
    "json",
    "web.jsx",
    "jsx"
  ];
  const resolveModule = (resolveFn, filePath) => {
    const extension = moduleFileExtensions.find(
      (extension2) => _fsextra2.default.existsSync(resolveFn(`${filePath}.${extension2}`))
    );
    if (extension) {
      return resolveFn(`${filePath}.${extension}`);
    }
    return resolveFn(`${filePath}.js`);
  };
  const paths = {
    dotenv: resolveApp(".env"),
    appPath: resolveApp("."),
    appDist: resolveApp(distDir),
    appPublic: resolveApp("public"),
    appHtml: resolveApp("public/index.html"),
    appIndexJs: resolveModule(resolveApp, "src/index"),
    appPackageJson: resolveApp("package.json"),
    appSrc: resolveApp("src"),
    appTsConfig: resolveApp("tsconfig.json"),
    appJsConfig: resolveApp("jsconfig.json"),
    proxySetup: resolveApp("src/setupProxy.js"),
    appNodeModules: resolveApp("node_modules"),
    appWebpackCache: resolveApp("node_modules/.cache"),
    appTsBuildInfoFile: resolveApp("node_modules/.cache/tsconfig.tsbuildinfo"),
    swSrc: resolveModule(resolveApp, "src/service-worker"),
    publicUrlOrPath,
    svgSpritePath: resolveApp("src/icons/svg"),
    moduleFileExtensions
  };
  return paths;
};


exports.getPaths = getPaths;
