"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var _path = require('path'); var _path2 = _interopRequireDefault(_path);
var _fsextra = require('fs-extra'); var _fsextra2 = _interopRequireDefault(_fsextra);
var _webpack = require('webpack'); var _webpack2 = _interopRequireDefault(_webpack);
var _resolve = require('resolve'); var _resolve2 = _interopRequireDefault(_resolve);
var _htmlwebpackplugin = require('html-webpack-plugin'); var _htmlwebpackplugin2 = _interopRequireDefault(_htmlwebpackplugin);
var _minicssextractplugin = require('mini-css-extract-plugin'); var _minicssextractplugin2 = _interopRequireDefault(_minicssextractplugin);
var _webpackmanifestplugin = require('webpack-manifest-plugin');
var _webpackbundleanalyzer = require('webpack-bundle-analyzer');
var _workboxwebpackplugin = require('workbox-webpack-plugin'); var _workboxwebpackplugin2 = _interopRequireDefault(_workboxwebpackplugin);
var _eslintwebpackplugin = require('eslint-webpack-plugin'); var _eslintwebpackplugin2 = _interopRequireDefault(_eslintwebpackplugin);
var _stylelintwebpackplugin = require('stylelint-webpack-plugin'); var _stylelintwebpackplugin2 = _interopRequireDefault(_stylelintwebpackplugin);
var _casesensitivepathswebpackplugin = require('case-sensitive-paths-webpack-plugin'); var _casesensitivepathswebpackplugin2 = _interopRequireDefault(_casesensitivepathswebpackplugin);
var _reactrefreshwebpackplugin = require('@pmmmwh/react-refresh-webpack-plugin'); var _reactrefreshwebpackplugin2 = _interopRequireDefault(_reactrefreshwebpackplugin);
var _webpackbar = require('webpackbar'); var _webpackbar2 = _interopRequireDefault(_webpackbar);
var _InterpolateHtmlPlugin = require('react-dev-utils/InterpolateHtmlPlugin'); var _InterpolateHtmlPlugin2 = _interopRequireDefault(_InterpolateHtmlPlugin);
var _InlineChunkHtmlPlugin = require('react-dev-utils/InlineChunkHtmlPlugin'); var _InlineChunkHtmlPlugin2 = _interopRequireDefault(_InlineChunkHtmlPlugin);
var _ForkTsCheckerWebpackPlugin = require('react-dev-utils/ForkTsCheckerWebpackPlugin'); var _ForkTsCheckerWebpackPlugin2 = _interopRequireDefault(_ForkTsCheckerWebpackPlugin);
var _ModuleNotFoundPlugin = require('react-dev-utils/ModuleNotFoundPlugin'); var _ModuleNotFoundPlugin2 = _interopRequireDefault(_ModuleNotFoundPlugin);
var _getPaths = require('./getPaths');
var _getEnv = require('./getEnv');
var _getUserConfig = require('./getUserConfig');
const getPlugins = () => {
  const isEnvDevelopment = process.env.NODE_ENV === "development";
  const isEnvProduction = process.env.NODE_ENV === "production";
  const useSourceMap = process.env.USE_SOURCEMAP === "true";
  const useBundleAnalyzerPlugin = process.env.USE_ANALYZE === "true";
  const paths = _getPaths.getPaths.call(void 0, );
  const { eslint, stylelint, typescript } = _getUserConfig.getUserConfig.call(void 0, "plugin");
  const env = _getEnv.getEnv.call(void 0, paths.publicUrlOrPath.slice(0, -1));
  return [
    // Generates an `index.html` file with the <script> injected.
    new (0, _htmlwebpackplugin2.default)({
      inject: true,
      template: paths.appHtml,
      ...isEnvProduction ? {
        minify: {
          removeComments: true,
          collapseWhitespace: true,
          removeRedundantAttributes: true,
          useShortDoctype: true,
          removeEmptyAttributes: true,
          removeStyleLinkTypeAttributes: true,
          keepClosingSlash: true,
          minifyJS: true,
          minifyCSS: true,
          minifyURLs: true
        }
      } : void 0
    }),
    // Inlines the webpack runtime script. This script is too small to warrant
    // a network request.
    // https://github.com/facebook/create-react-app/issues/5358
    isEnvProduction && new (0, _InlineChunkHtmlPlugin2.default)(_htmlwebpackplugin2.default, [/runtime~.+[.]js/]),
    // Makes some environment variables available in index.html.
    // The public URL is available as %PUBLIC_URL% in index.html, e.g.:
    // <link rel="icon" href="%PUBLIC_URL%/favicon.ico">
    // It will be an empty string unless you specify "homepage"
    // in `package.json`, in which case it will be the pathname of that URL.
    new (0, _InterpolateHtmlPlugin2.default)(_htmlwebpackplugin2.default, env.raw),
    // This gives some necessary context to module not found errors, such as
    // the requesting resource.
    new (0, _ModuleNotFoundPlugin2.default)(paths.appPath),
    // Makes some environment variables available to the JS code, for example:
    // if (process.env.NODE_ENV === 'production') { ... }. See `./env.js`.
    // It is absolutely essential that NODE_ENV is set to production
    // during a production build.
    // Otherwise React will be compiled in the very slow development mode.
    new _webpack2.default.DefinePlugin(env.stringified),
    // Experimental hot reloading for React .
    // https://github.com/facebook/react/tree/main/packages/react-refresh
    isEnvDevelopment && new (0, _reactrefreshwebpackplugin2.default)({
      overlay: false
    }),
    // Watcher doesn't work well if you mistype casing in a path so we use
    // a plugin that prints an error when you attempt to do this.
    // See https://github.com/facebook/create-react-app/issues/240
    isEnvDevelopment && new (0, _casesensitivepathswebpackplugin2.default)(),
    isEnvProduction && new (0, _minicssextractplugin2.default)({
      // Options similar to the same options in webpackOptions.output
      // both options are optional
      filename: "static/css/[name].[contenthash:16].css",
      chunkFilename: "static/css/[name].[contenthash:16].chunk.css"
    }),
    // Generate an asset manifest file with the following content:
    // - "files" key: Mapping of all asset filenames to their corresponding
    //   output file so that tools can pick it up without having to parse
    //   `index.html`
    // - "entrypoints" key: Array of files which are included in `index.html`,
    //   can be used to reconstruct the HTML if necessary
    isEnvProduction && new (0, _webpackmanifestplugin.WebpackManifestPlugin)({
      fileName: "asset-manifest.json",
      publicPath: paths.publicUrlOrPath,
      generate: (seed, files, entrypoints) => {
        const manifestFiles = files.reduce((manifest, file) => {
          manifest[file.name] = file.path;
          return manifest;
        }, seed);
        const entrypointFiles = entrypoints.main.filter(
          (fileName) => !fileName.endsWith(".map")
        );
        return {
          files: manifestFiles,
          entrypoints: entrypointFiles
        };
      }
    }),
    // Generate a service worker script that will precache, and keep up to date,
    // the HTML & assets that are part of the webpack build.
    isEnvProduction && _fsextra2.default.existsSync(paths.swSrc) && new _workboxwebpackplugin2.default.InjectManifest({
      swSrc: paths.swSrc,
      dontCacheBustURLsMatching: /\.[0-9a-f]{8}\./,
      exclude: [/\.map$/, /asset-manifest\.json$/, /LICENSE/],
      // Bump up the default maximum size (2mb) that's precached,
      // to make lazy-loading failure scenarios less likely.
      // See https://github.com/cra-template/pwa/issues/13#issuecomment-722667270
      maximumFileSizeToCacheInBytes: 5 * 1024 * 1024
    }),
    // TypeScript type checking
    _optionalChain([typescript, 'optionalAccess', _ => _.enable]) && new (0, _ForkTsCheckerWebpackPlugin2.default)(
      _getUserConfig.deepMergeWithArray.call(void 0, _optionalChain([typescript, 'optionalAccess', _2 => _2.options]), {
        async: isEnvDevelopment,
        typescript: {
          typescriptPath: _resolve2.default.sync("typescript", {
            basedir: paths.appNodeModules
          }),
          configOverwrite: {
            compilerOptions: {
              sourceMap: isEnvProduction ? useSourceMap : isEnvDevelopment,
              skipLibCheck: true,
              inlineSourceMap: false,
              declarationMap: false,
              noEmit: true,
              incremental: true,
              tsBuildInfoFile: paths.appTsBuildInfoFile
            }
          },
          context: paths.appPath,
          diagnosticOptions: {
            syntactic: true
          },
          mode: "write-references"
          // profile: true,
        },
        issue: {
          // This one is specifically to match during CI tests,
          // as micromatch doesn't match
          // '../cra-template-typescript/template/src/App.tsx'
          // otherwise.
          include: [
            { file: "../**/src/**/*.{ts,tsx}" },
            { file: "**/src/**/*.{ts,tsx}" }
          ],
          exclude: [
            { file: "**/src/**/__tests__/**" },
            { file: "**/src/**/?(*.){spec|test}.*" },
            { file: "**/src/setupProxy.*" },
            { file: "**/src/setupTests.*" }
          ]
        },
        logger: {
          infrastructure: "silent"
        }
      })
    ),
    _optionalChain([eslint, 'optionalAccess', _3 => _3.enable]) && new (0, _eslintwebpackplugin2.default)(
      _getUserConfig.deepMergeWithArray.call(void 0, _optionalChain([eslint, 'optionalAccess', _4 => _4.options]), {
        extensions: ["js", "mjs", "jsx", "ts", "tsx"],
        formatter: require.resolve("react-dev-utils/eslintFormatter"),
        eslintPath: require.resolve("eslint"),
        failOnError: true,
        context: paths.appSrc,
        cache: true,
        cacheLocation: _path2.default.resolve(
          paths.appNodeModules,
          ".cache/.eslintcache"
        ),
        cwd: paths.appPath
      })
    ),
    _optionalChain([stylelint, 'optionalAccess', _5 => _5.enable]) && new (0, _stylelintwebpackplugin2.default)(
      _getUserConfig.deepMergeWithArray.call(void 0, _optionalChain([stylelint, 'optionalAccess', _6 => _6.options]), {
        extensions: ["less", "scss", "sass", "stylus", "styl", "css"],
        stylelintPath: require.resolve("stylelint"),
        failOnError: isEnvProduction,
        context: paths.appSrc,
        cache: true,
        cacheLocation: _path2.default.resolve(
          paths.appNodeModules,
          ".cache/.stylelintcache"
        ),
        cwd: paths.appPath
      })
    ),
    useBundleAnalyzerPlugin && new (0, _webpackbundleanalyzer.BundleAnalyzerPlugin)(),
    new (0, _webpackbar2.default)()
  ].filter(Boolean);
};


exports.getPlugins = getPlugins;
